%global python3_pkgversion 3.11
%global pypi_name jaraco-context
%global srcname jaraco_context
%global pypi_version 6.0.1

Name:           python-%{pypi_name}
Version:        %{pypi_version}
Release:        1%{?dist}
Summary:        Context managers by jaraco

# Check if the automatically generated License and its spelling is correct for Fedora
# https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/
License:        MIT
URL:            https://github.com/jaraco/jaraco.context
Source:         %{pypi_source jaraco_context}

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-pytest
BuildRequires:  python%{python3_pkgversion}-setuptools >= 56
BuildRequires:  python%{python3_pkgversion}-setuptools_scm >= 3.4.1
BuildRequires:  python%{python3_pkgversion}-wheel
BuildRequires:  pyproject-rpm-macros


# Fill in the actual package description to submit package to Fedora
%global _description %{expand:
See the docs linked from the badge above for the full details, but here are some features that may be of interest.

ExceptionTrap provides a general-purpose wrapper for trapping exceptions and then acting on the outcome.
Includes passes and raises decorators to replace the result of a wrapped function by a boolean indicating the outcome of the exception trap.
 See this keyring commit for an example of it in production.

suppress simply enables contextlib.suppress as a decorator.

on_interrupt is a decorator used by CLI entry points to affect the handling of a KeyboardInterrupt. Inspired by Lucretiel/autocommand#18.

pushd is similar to pytest’s monkeypatch.chdir or path’s default context, changes the current working directory for the duration of the context.

tarball will download a tarball, extract it, change directory, yield, then clean up after. Convenient when working with web assets.

null is there for those times when one code branch needs a context and the other doesn’t; this null context provides symmetry across those branches.}

%description %_description

%package -n     python%{python3_pkgversion}-jaraco-context
Summary:        %{summary}
Requires:       python%{python3_pkgversion}-backports-tarfile

%description -n python%{python3_pkgversion}-jaraco-context %_description

# For official Fedora packages, review which extras should be actually packaged
# See: https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#Extras


%prep
%autosetup -p1 -n %{srcname}-%{version}


%build
%pyproject_wheel


%install
%pyproject_install
# For official Fedora packages, including files with '*' +auto is not allowed
# Replace it with a list of relevant Python modules/globs and list extra files in %%files
%pyproject_save_files '*' +auto


%files -n python%{python3_pkgversion}-%{pypi_name} -f %{pyproject_files}
%doc README.rst
%license LICENSE
%{python3_sitelib}/jaraco
%{python3_sitelib}/jaraco.context-%{pypi_version}.dist-info


%changelog
* Fri Feb 21 2025 Carlos Heiras <carlos.heiras@oracle.com> - 6.0.1-1
- Initial release
